<!--suppress JSUnresolvedReference -->
<script setup lang="ts">
import '@distromade/distro-ui/style.css';
import '@distromade/distro-cms/style.css';
import Cookies from 'cookie-universal';
import { LoginForm, PageWrapper } from '@distromade/distro-cms';
import type {
  LoginResponse,
  UnsavedChangesType,
  Nullable,
} from '@distromade/distro-cms/dist/types';
import type { FetchError } from 'ofetch';

import { useRoute, useFetch, useHead, useRuntimeConfig, computed } from '#imports';
import { useContentStore, useOrgStore } from '~/stores';
import { getFetchErrorMessage } from '~/utils';

const isPreRendering = !!process.env.PRERENDERING_MODE;

const contentStore = useContentStore();
const orgStore = useOrgStore();
const route = useRoute();
const { apiRoot, orgId } = useRuntimeConfig().public;

const org = await orgStore.fetchOrg();

const rootTitle = computed(() => {
  if (orgStore.org?.website?.active === false) {
    return 'Coming Soon';
  }
});

async function login(email: string, password: string): Promise<LoginResponse | string> {
  const url = `${apiRoot}/sites/${orgId}/login`;
  const { data, error } = await useFetch(url, {
    method: 'POST',
    body: { email, password },
  });

  if (error.value) {
    return getFetchErrorMessage(error.value);
  }
  return data.value as LoginResponse;
}

async function save(
  changes: UnsavedChangesType,
  cookies: Nullable<LoginResponse>,
): Promise<string | undefined> {
  const contents = Object.entries(changes).map(([_, content]) => {
    const { markdownElements, plainTextElements, pageDescription, pageTitle, __filePath } =
      content;
    return {
      filePath: `content/${__filePath}`,
      cms: {
        pageTitle,
        pageDescription,
        markdownElements,
        plainTextElements,
      },
    };
  });

  const url = `${apiRoot}/sites/${orgId}/content`;
  const { token, refreshToken, refreshesAt, expiresAt } = cookies;

  // user may have manually deleted cookies
  if (!token || !refreshToken || !refreshesAt || !expiresAt) {
    return 'Something went wrong. Please try logging in again.';
  }

  try {
    const response = await $fetch.raw(url, {
      method: 'PUT',
      body: { contents },
      ignoreResponseError: true,
      headers: {
        Authorization: `Bearer ${token}`,
        'Distro-Refresh-Token': refreshToken,
        'Distro-Refreshes-At': refreshesAt.toString(),
        'Distro-Expires-At': expiresAt.toString(),
      },
    });

    const xToken = response.headers.get('Distro-Token');
    const xRefreshToken = response.headers.get('Distro-Refresh-Token');
    const xRefreshesAt = response.headers.get('Distro-Refreshes-At');

    if (xToken && xRefreshToken && xRefreshesAt) {
      Cookies().set('distro-cms-token', xToken);
      Cookies().set('distro-cms-refresh-token', xRefreshToken);
      Cookies().set('distro-cms-refreshes-at', xRefreshesAt);
    }
  } catch (error) {
    return getFetchErrorMessage(error as FetchError<any>);
  }
}

useHead({
  title: rootTitle.value,
});
</script>

<template>
  <PageWrapper
    v-if="org?.website?.active || isPreRendering"
    :content="contentStore.content"
    :route="route.path"
    :save="save"
  >
    <template #login-form>
      <LoginForm :login="login" />
    </template>

    <NuxtLoadingIndicator color="#222" :height="2" :throttle="400" />
    <NuxtLayout>
      <NuxtPage />
    </NuxtLayout>
  </PageWrapper>

  <main v-else class="p-4 flex justify-center items-center w-screen h-screen">
    <div class="text-center">
      <h1 class="text-center">Coming soon...</h1>
      <p class="mt-5">
        Powered by
        <a href="https://distromade.com" target="_blank" class="text-blue-800">Distro</a>
      </p>
    </div>
  </main>
</template>
